#ifndef FILE_H
#define FILE_H
#include <stdio.h>

#define EXE_DIRNAME_MAX 1024
#define MAKEDIR_MODE 0744

// argv[0]ȡ֥ǥ쥯ȥѥ
// HOMEΥ֥ǥ쥯ȥ̾ե̾Ϳ롣
// ֥ǥ쥯ȥꤹ
// - dpathNULLǤʤСͤ
// - dpathNULLʤ顢
//     - $HOMEƤ顢ľ(save_dirname̾)ǥ쥯ȥ
//     - $HOME̤ʤ顢¹ԥե¸ߤǥ쥯ȥ
// Ԥξ硢ǥ쥯ȥ꤬ʤк롣
// ֥ǥ쥯ȥκ˼Ԥ顢ܥեΥ֡ɵǽ̵
// ˽Ǥ0ǽ̵ξ0֤
int file_init(char *argv0, char *dpath, char *save_dname, char *log_fname);

// ¹ԥե¸ߤǥ쥯ȥѥ֤
char *get_exe_dpath(char *argv0);

// ֥ǥ쥯ȥΥѥ֤
char *get_save_dpath(void);

// ֥ǥ쥯ȥdpathѹ
// file_initƱ͡ǥ쥯ȥ꤬ʤкԤ鵡ǽ̵
// ˽Ǥ0ǽ̵ξ0֤
int set_save_dpath(char *dpath);

// ǡ¸ǥ쥯ȥfilename¸뤿Υѥfpath˳Ǽ
// ѥƬؤΥݥ(i.e. fpath)֤
char *get_data_fpath(char *filename, char *fpath);

// SAVE_DIR˥⡼modeǥǡեfile򳫤
// mode'r'ޤȤapplication_idפʤХեϥNULL֤
// (application_id==NULLʤץå򤷤ʤ)
// major_version / minor_versionsˤϥեΥСͤǼ
FILE *open_data(char *filename, char *mode,
                char *application_id, int application_id_size,
                unsigned char *major_version, unsigned char *minor_version);

// unsigned intͥåȥХȥǥե뤫ɤ߽Ф/˽񤭹
// valueλؤ褫numĤunsigned intоݤȤ
// ɤ߽񤭤4ХʬǸ
// sizeof(unsigned int) > 4ΤȤϲ4ХȤΤߤоݤˤʤ
int fwrite_uint(FILE *fp, unsigned int *value, int num);
int fread_uint(FILE *fp, unsigned int *value, int num);

// եΥѥꤹ롣
// set_save_dirname()˸Ƥɬפ롣
// getarg.c:getarg()ǼưŪ˸ƤФ롣
int set_log_fpath(char *log_filename);
int print_log(const char *msg);
int log_warn(char *fmt, ...);
int log_error(char *fmt, ...);

// dpathǼǥ쥯ȥ
// pathκǲؤΥǥ쥯ȥΤߺ롣
//   Υǥ쥯ȥ꤬¸ߤʤмԤ
// 0Ի0֤
int make_dir(char *dpath);
// ǥ쥯ȥdpath¸ߤʤ0֤
int check_dir(char *dpath);
// pathpath+".000", +".001", ...˥͡ष褦Ȥ
// 0֤+".999"ޤǤ٤ƻʤ鼺Ԥ-1֤
int rename_data(char *filename);

void set_log_output_stderr(int val);
void set_log_output_file(int val);
void set_log_limit(long val);

#endif
