#ifndef FONT_H
#define FONT_H
#include "config.h"
/*
  font ID (fid):
        1ʸʬΥեȤμ̻(եID)font_id_tɽ졢(֤)1ɡ
        ܥ饤֥ѰդʸΤߤֹ̤椪ҤƤ롣
        äơѰդ줿ʸҤѤƻǽ
        ѰդƤʤʸϰʤ
        ޤASCIIEUCʤɤʸɤȤפʤΤǡ
        charʸǡѴɬס
  font sequence (fontseq):
        0İʾfont_id_t¤Ӥǡͤfi_endǤΡ
        եID¤ӤǤꡢĤʸб롣
        Cchar*ˤʸ򰷤ˡ˽򤷤ƤΤǡ
        font_id_t*ǰĤfontseqɽ
        fontseq򰷤ؿϤΥݥ󥿤äơ
        fi_endǥߥ͡Ȥ줿ʸ(ե)¤ӤȤƽ롣
        alloc_fontseq()ȤȡʸfontseqѴݥ󥿤Ǥ
        fontseqμΰϼưݤ롣
   fontseq array
        fontseqʣʸޤȤư˻ѡ
        
*/

#define FONTSIZE 16

typedef enum {
    //    fi_invalid = -1,
    fi_begin = 0,
    fi_tofu = 0,
    fi_space,
    fi_kuten,
    fi_toten,
	fi_nakaguro,
	fi_question,
	fi_bikkuri,
    fi_dash,
	fi_ldots,
	fi_lparen,
	fi_rparen,
	fi_lbracket,
	fi_rbracket,
	fi_lkagikakko,
	fi_rkagikakko,
    fi_a,
    fi_i,
    fi_u,
    fi_e,
    fi_o,
    fi_la,
    fi_li,
    fi_lu,
    fi_le,
    fi_lo,
    fi_ka,
    fi_ki,
    fi_ku,
    fi_ke,
    fi_ko,
    fi_ga,
    fi_gi,
    fi_gu,
    fi_ge,
    fi_go,
    fi_sa,
    fi_si,
    fi_su,
    fi_se,
    fi_so,
    fi_za,
    fi_zi,
    fi_zu,
    fi_ze,
    fi_zo,
    fi_ta,
    fi_ti,
    fi_tu,
    fi_te,
    fi_to,
    fi_ltu,
    fi_da,
    fi_di,
    fi_du,
    fi_de,
    fi_do,
    fi_na,
    fi_ni,
    fi_nu,
    fi_ne,
    fi_no,
    fi_ha,
    fi_hi,
    fi_hu,
    fi_he,
    fi_ho,
    fi_ba,
    fi_bi,
    fi_bu,
    fi_be,
    fi_bo,
    fi_pa,
    fi_pi,
    fi_pu,
    fi_pe,
    fi_po,
    fi_ma,
    fi_mi,
    fi_mu,
    fi_me,
    fi_mo,
    fi_ya,
    fi_yu,
    fi_yo,
    fi_lya,
    fi_lyu,
    fi_lyo,
    fi_ra,
    fi_ri,
    fi_ru,
    fi_re,
    fi_ro,
    fi_wa,
    fi_wo,
    fi_n,

    fi_n0,
    fi_n1,
    fi_n2,
    fi_n3,
    fi_n4,
    fi_n5,
    fi_n6,
    fi_n7,
    fi_n8,
    fi_n9,

    fi_al_c,
    fi_al_f,
    fi_al_o,
    fi_al_n,
    fi_al_s,

    fi_ky_g,
    fi_ky_p,
    fi_ky_r,
    fi_ky_q,

	fi_ky_leftarrow,
	fi_ky_rightarrow,
	fi_ky_uparrow,
	fi_ky_downarrow,
	fi_ky_spacel,
	fi_ky_spacer,
	fi_ky_esc,
	fi_ky_enter,

	fi_time,
	fi_walk,
	fi_jump,
	fi_air,
	fi_lift,
	fi_blast,
	fi_sting,
	fi_bone,
	fi_smash,
	fi_flame,
	fi_goal,
	fi_gondin,
	fi_gondin_lost,
	fi_chee,
	fi_hatopo,
	fi_yaramasi,
	fi_gagga,
	fi_fwall,
	fi_iwall,
    fi_switch,
	fi_teleporter,
	fi_sue,
	fi_ojigiri,
	fi_chu,
	fi_jumeme,
	fi_siguku,
	fi_mingo,

	fi_plus,
	fi_multiply,
    fi_slash,
	fi_equal,
    fi_op_le,
    fi_op_ge,
    fi_op_lt,
    fi_op_gt,
	fi_checkbox,
	fi_check,
	fi_check_weak,
	fi_star_off,
	fi_star_on,

    fi_end
} font_id_t;

// [FontName]ǥեȤꤹ뤿Υơ֥륨ȥ
typedef struct {
    char *font_name;
    font_id_t fid;
} font_name_t;

typedef struct {
    font_id_t fid; // եȤμ̻(1)
    char *mbchr;   // ΥեȤбʸ(ޥХʸб뤿ʸ)
    char **xpm;    // եȲxpmǡ
} font_info_t;

// fidѴfixκ
// ơ֥fix2fidϤΥǳݤ
// fix
// fidȰабɬפ뤬Ϣ³ƤɬפϤʤ
// jcode֤ޥХʸcodeѴ׻Ϸڤɤ
//   stringfixͳfidѴϤʤ٤˹ԤȤꤷƤΤǡ
//   󥹥ȥХإåɤϤۤɵˤʤɤ
// Ū˰ʸˤĤfixͤѹƤ⡢fidȤбط
//   font_info_listͳǼư׻Τʤ
#define FIX_MAX (1024*1024) 

// [FontName]ǻȤե̾θĿ
#define FONT_NAME_NUM_MAX 1024

// ¹ѹʤʸƥˤĤƤϡ
// alloc_fontseqʸϤȤǡfontseqؤΥݥ󥿤ѴǤ롣
// ξ硢fontseqμΤϥХåե˼ưݤ롣
// ХåեϼΥޥͥХȤưݤ졢
// դ٤Ʊɲóݤ
#define FONTSEQ_BUF_SIZE 64*1024


#define FONTSEQ_ARRAY_BUF_SIZE 64
#define FONTSEQ_ARRAY_PACK_LIMIT (FONTSEQ_ARRAY_BUF_SIZE/2)

void font_init(void);
void draw_font(int x, int y, font_id_t fid);
void draw_fontseq(int x, int y, font_id_t *fid);
int mbchr2fix(char **chr);
int str2fontseq(char *str, font_id_t fid[]);
font_id_t *alloc_fontseq(char *str);
font_id_t **alloc_fontseq_array(int size);
int fontseq_cpy(font_id_t *dest, font_id_t *src);
int fontseq_len(font_id_t *fontseq);
int fontseq_cat(font_id_t *dest, font_id_t *src);
int uint2fontseq(unsigned int n, int len, font_id_t fid[]);
int inc_fontseq(int len, font_id_t fid[]);
int dec_fontseq(int len, font_id_t fid[]);

#endif
