#ifndef RECORD_H
#define RECORD_H
#include "config.h"
#include "font.h"
#include "obj.h"

typedef struct {
    unsigned int min;
    unsigned int max;
} minmax_t;

// ѥȷεϿȥ
typedef enum {
    re_invalid = -1,
    re_begin = 0,
    re_score = 0,    // ȤƤ
    re_time,         // Τꤸ
    re_gondin_eaten, // Ǥ򿩤٤
	re_gondin_lost,  // Ǥ򼺤ä
    re_clear,        // ꥢ˴killed_by_xxx׻Ǥ
    re_walk_frame,   // Ԥե졼
    re_air_frame,    // ˤե졼
    re_jump_count,   // פ
    re_slide_frame,   // ٤äե졼
	re_lift_frame,   // ե/ˤ㤢Ѥˤե졼
	re_blast_count,  // äˤդäȤФ줿
	re_switch_count,  // åڤؤ
	re_teleport_count,  // ƥݡȲ

    // ̤λ˴
    // Ƚ塢ȤФޤΤɤ˻ɤäʤɤ϶̤ʤ
    re_killed_by_pierced,  // ޤˤä
    re_killed_by_ojigiri,  // ˿٤줿
    re_killed_by_smash,    // եȤ˶ޤ줿
    re_killed_by_flame,    // ˾Ƥ줿
	re_killed_by_barrier,  // ХꥢǴŤ
	// ƥλ˴
    re_hatopo_killed,
    re_yaramasi_killed,
    re_gagga_killed,
    re_ojigiri_killed,
    re_sue_killed,
    re_chu_killed,
    re_mingo_killed,
    re_jumeme_killed,
    re_siguku_killed,
    re_fwall_destroyed,
    re_iwall_destroyed,
    re_end = 256
} record_entry_t;

typedef struct {
    unsigned int min[re_end];
    unsigned int max[re_end];
    unsigned int sum[re_end];
} record_t;

typedef struct {
    record_entry_t entry;
    char *fontname;
    char *description;
    int show_minmax;
    int show_sum;
} record_info_t;

typedef struct {
	obj_type_t type;
	record_entry_t entry;
} ot2re_info_t;

#define RecordMin(r, re) (r.min[re])
#define RecordMax(r, re) (r.max[re])
#define RecordSum(r, re) (r.sum[re])

#define MINMAX_MAX 0x1000000

void record_init(void);
font_id_t *get_record_icon(record_entry_t re);
int get_record_showentry_num(void);
record_info_t *get_record_info(int no);
record_entry_t kill_ot2re(obj_type_t type);
char *get_record_description(record_entry_t entry);

#endif

